#include <stdio.h>
#include <boost/container/vector.hpp>

template<typename T, unsigned N>
class SampleAllocator1 {
public:
	typedef T value_type;
	SampleAllocator1() { }
	T* allocate(unsigned n) { assert(n == N); return reinterpret_cast<T*>(buf_); }
	void  deallocate(T*, unsigned) { }
	bool operator == (SampleAllocator1 const & ) const { return false; }
	bool operator != (SampleAllocator1 const & ) const { return true; }
private:
	typedef	double	buf_t;
	buf_t	buf_[(N*sizeof(T)+sizeof(buf_t)-1) / sizeof(buf_t)];
};

void sample1()
{
	enum { CAPA = 112 };
	typedef SampleAllocator1<char, CAPA>	Allocator;
	printf("sizeof(Allocator)=%d\n", sizeof(Allocator));
	typedef boost::container::vector<char, Allocator >	Vector;
	Vector v1;
	printf("v1: p=%p, size=%d, cap=%d sizeof=%d\n", v1.data(), v1.size(), v1.capacity(), sizeof(v1));
	v1.reserve(CAPA);
	v1.push_back('a');
	v1.push_back('b');
	v1.push_back('\0');
	printf("v1: p=%p, size=%d, cap=%d sizeof=%d\n", v1.data(), v1.size(), v1.capacity(), sizeof(v1));
	Vector v2(CAPA);
	printf("v2: p=%p, size=%d, cap=%d sizeof=%d\n", v2.data(), v2.size(), v2.capacity(), sizeof(v2));
	v2 = v1;
	printf("v2: p=%p, size=%d, cap=%d sizeof=%d\n", v2.data(), v2.size(), v2.capacity(), sizeof(v2));
	printf("%s\n", &v1[0]);
	printf("%s\n", &v2[0]);
}
