#include <stdio.h>
#include <boost/container/map.hpp>
#include <boost/container/list.hpp>
#include <boost/container/string.hpp>
#include <boost/container/scoped_allocator.hpp>
#include <boost/foreach.hpp>

// X^bNŉ̊ȈՃAP[^.
template<unsigned N>
class SampleAlloc3 {
public:
	SampleAlloc3() : size_(0) { }
	void* allocate(unsigned n) {
		assert(size_+n <= N);
		void* p = ptr(size_);
		size_ += n;
		return p;
	}
	void  deallocate(void*, unsigned) { /*dummy*/ }
private:
	typedef double buf_t;
	void*		ptr(unsigned n=0) { return (char*)buf_ + ((n + sizeof(buf_t)-1) & ~(sizeof(buf_t)-1)); }
private:
	unsigned	size_;
	buf_t		buf_[N / sizeof(buf_t)];
};

template<unsigned SAMPLE_ALLOC3_SIZE>
class Hoge {
public:
	Hoge() : strIntMap_(std::less<String>(), MapAllocator(StrIntPairAlloc(&smpAlc3_))) {}
	void insert(const char* name, int val) {
		//strIntMap_[String(name, &smpAlc3_)] = val;
		strIntMap_.emplace( name, val );
	}
	void printAll() {
		BOOST_FOREACH(StrIntPair p , strIntMap_)
			printf("%s = %d\n", p.first.c_str(), p.second);
	}
private:
	typedef SampleAlloc3<SAMPLE_ALLOC3_SIZE> Alloc;
	template<typename T>
	class SampleAllocator3 {
	public:
		typedef T value_type;
		// SampleAllocator3() : alc_(0) {}	// ftHgRXgN^͗pӂȂقS.
		SampleAllocator3(Alloc* alc) : alc_(alc) { }
		template<typename U> SampleAllocator3(SampleAllocator3<U> const& r) : alc_(r.detail_get_ptr()) { }
		T* allocate(unsigned n) { return reinterpret_cast<T*>(alc_->allocate(n*sizeof(T))); }
		void  deallocate(T* p, unsigned n) { alc_->deallocate(p,n*sizeof(T)); }
		bool operator == (SampleAllocator3 const & ) const { return false; }
		bool operator != (SampleAllocator3 const & ) const { return true; }

		Alloc* detail_get_ptr() const { return alc_; }
	private:
		Alloc*		alc_;
	};
	typedef boost::container::basic_string<char, std::char_traits<char>, SampleAllocator3<char> >	String;
	typedef std::pair<const String, int>	StrIntPair;
	typedef SampleAllocator3<StrIntPair>	StrIntPairAlloc;
	typedef boost::container::scoped_allocator_adaptor< StrIntPairAlloc >			MapAllocator;
	typedef boost::container::map<String, int, std::less<String>, MapAllocator >	StrIntMap;
private:
	SampleAlloc3<SAMPLE_ALLOC3_SIZE>	smpAlc3_;
	StrIntMap							strIntMap_;
};

void sample3()
{
	Hoge<1024>	hoge;
	hoge.insert("xyz", 1);
	hoge.insert("abcdefghijklmnopqrstuvwxyz", 2);
	hoge.insert("1234567890", 3);
	hoge.printAll();
}
